.\" @(#)tdl.man	4.0 tdl version 9/11/92
.TH TDL 1 "11 Sept 1992"
.SH NAME
tdl \- A Command Line Version of XVTDL
.SH SYNOPSIS
.B tdl
[
.I options
]
.\" ========================================================================
.SH DESCRIPTION
.LP
.B tdl
is a facility that will list and add to the to do list databases created
by 
.B xvtdl(L)
Its various options make it easy to use and flexible.  Its primary use is
to list todo lists from a non-window interface.  It can easily be placed
in cron databases or executed from shell startup scripts.
.LP
Note that 
.B tdl
reads and processes the ".xvtdlrc" X resource database.  This means that
defaults set up through 
.B xvtdl(L)
will be used without further intervention by
.B tdl.
.LP
The user is referred to
.B xvtdl(L)
for the definition of terms and understanding of how to completely create
and manipulate todo list databases.
.\" ========================================================================
.SH OPTIONS
.LP
.TP
-add
This begins a dialog with the user directed at adding an entry to the
specified database (or to the default database if none specified).  
Except for the "-f" options, all other arguments are ignored when the
program encounters a "-add".
.TP
-all
This specifies that all categories are to be listed together (default).
.TP
-categories
This lists the names of categories in the todo list database given.
Subcategories are given as indented from their parents.  All options,
except for the "-f" option, are ignored when this option is given.
.TP
-category catname
Use the category "catname" rather than all categories for listing.
.TP
-date date
List the date specified as "date" rather than the current date. This is
given in "mm/dd/yy" format.
.TP
-deadline 
Normally, 
.B tdl
will not check deadlines when examining items for listing.  Specifying
this option will force
.B tdl
to check the deadline of each item when examined for listing.  
.PP
.RS
Note that using this option could be an inconvenience.  For example, if a
deadline action is to mail a message after the deadline, and the current
date is after the deadline, checking the list with deadline checking
several times a day can result in several mail messages.
.RE
.TP
-f file
Use "file" instead of $HOME/.tododb
.TP
-help
This will print a usage message and quit.
.TP
-include
When printing the list, include checked items.  The default is not to
include these items.
.TP
-list
List the database for a particular date (default).
.TP
-print
Print the database for a particular date.
.TP
-printer printer
Print the list on the printer "printer". The default is "lp".
.TP
-postscript
Print the list in PostScript form.  The default is to print the list
prepared for a plain ASCII printer.
.TP
-scale factor
Scale the PostScript output by the integer "factor".  Ignored if the
"-postscript" option is not used. 
.\" =======================================================================
.SH FILES 
.LP
.TP
$HOME/.tododb
This is the default to do list database.
.TP
/tmp/xvtdl*
When printing, this temporary file is used to store the list prior to
sending to the printer.
.\" =======================================================================
.SH SEE ALSO
cm(1) xvtdl(L)
.\" =======================================================================
.SH AUTHOR
.LP
The 
.B tdl
program was written by Mike Jipping, Hope College Department of Computer
Science.  All comments, praises, bug reports, and flames should be sent
to him at "jipping@cs.hope.edu".  He'll at least read your message.
.\" =======================================================================
.SH KNOWN BUGS
.LP
There are currently no known aspects of the program that corrupt the data
or crash the program.

